package asynch;

import java.util.concurrent.Future;

import javax.ejb.AsyncResult;
import javax.ejb.Asynchronous;
import javax.ejb.Lock;
import javax.ejb.LockType;
import javax.ejb.Singleton;

@Singleton
public class AsynchEjb {

	static int asyncFooCalls = 0;

	public AsynchEjb() {
	}

	@Asynchronous
	@Lock(LockType.WRITE)
	public Future<String> asynchFoo() {
		int currentActivation = ++asyncFooCalls;
		System.out.println("***" + this + " " + currentActivation
				+ " Asynch start");
		try {
			System.out.println("sleeping");
			Thread.sleep(50000);
			System.out.println("awake");
		} catch (InterruptedException e) {
			e.printStackTrace();
			System.out.println("***" + this + " " + currentActivation
					+ " Asynch fail");
			return new AsyncResult<String>(asyncFooCalls + "fail");
		}
		System.out.println("***" + this + " " + currentActivation
				+ " Asynch end");

		return new AsyncResult<String>(asyncFooCalls + "success");
	}
}
